#include "StdAfx.h"
#include "FloatEdit.h"

#include <sstream>

namespace FilterEdit
{
bool CFloatEdit::m_bInitialised = false;
CRegEx CFloatEdit::m_RegEx;

CFloatEdit::CFloatEdit () :
	CBaseEdit (&m_RegEx)
{
	if (!m_bInitialised)
	{
		//CString strRegEx (_T("[-+]?([0-9]*\\.)?[0-9]+([eE][-+]?[0-9]+)?"));
		CString strRegEx (_T("[-+]?([0-9]+(\\.[0-9]{0,2})?|.[0-9]{1,2})"));

		m_RegEx.assign (strRegEx);
		// Alternative from Mastering Regular Expressions by O'Reilly Press
		//m_RegEx.assign (_T("-?([0-9]+(\\.[0-9]*)?|\\.[0-9]+)"));
		m_bInitialised = true;
	}
}

CFloatEdit::~CFloatEdit ()
{
}

double CFloatEdit::GetValue () const
{
	CString strFloat;
	std::basic_stringstream<TCHAR> ss;
	double dValue = 0;

	GetWindowText (strFloat);
	ss << static_cast<const TCHAR *> (strFloat);
	ss >> dValue;
	return dValue;
}

BEGIN_MESSAGE_MAP(CFloatEdit, CBaseEdit)
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP()

void CFloatEdit::OnKillFocus (CWnd *pNewWnd)
{
	CString strFloat;
	CString strLeft;
	CString strRight;
	int iDot = -1;

	GetWindowText (strFloat);
	iDot = strFloat.Find ('.');	

	if (iDot > -1)
	{
		strLeft = strFloat.Left(iDot);
		strRight = strFloat.Mid(iDot + 1);
	}
	else
	{
		strLeft = strFloat;
	}

	if (strLeft.IsEmpty()) strLeft = '0';

	if (strRight.IsEmpty()) strRight = "00";
	else if (strRight.GetLength () == 1) strRight += '0';

	SetWindowText (strLeft + '.' + strRight);
	CBaseEdit::OnKillFocus (pNewWnd);
}
}
